/*================================
2016 SAS[U[
X@T
==================================*/

/*SAS on demand܂universityŎs̏ꍇ
  proc ds libs=work;ƂĂ*/


data TEST1;
X=1;
run;

/*PG1*/
data OUT1;
  set TEST1 end=eof;
  if _N_=1 then put 'NOTE:̊Jn';
  Y = X + 1;
  if eof then put 'NOTE:̏I';
run;

data TEST2;
ID=1;SEX='M';HEIGHT=167;WEIGHT=66;output;
ID=2;SEX='F';HEIGHT=155;WEIGHT=68;output;
ID=3;SEX='M';HEIGHT=177;WEIGHT=56;output;
ID=4;SEX='F';HEIGHT=1.6;WEIGHT=86;output;
ID=5;SEX='M';HEIGHT=183;WEIGHT=56;output;
ID=6;SEX='F';HEIGHT=158;WEIGHT=46;output;
run;

/*PG2*/
proc ds2 ;	                /*1*/
  data OUT1(overwrite=yes); /*2*/
  declare double Y;         /*3*/
  method init();         	/*4*/
  	put 'NOTE:̊Jn';
  end;
  method run();             /*5*/
	set  TEST1;             /*6*/
  	Y = X +1;
  end;
 method term();	            /*7*/
  put 'NOTE:̏I';
 end; 
 enddata;                   /*8*/
 run;                       /*9*/
quit;                      /*10*/


/*PG3*/
proc ds2 ;
 data _null_;             /*1*/
 method h_chk(double h);  /*2*/
 	if . < h < 100 then put
 	'WARNIG:PʊmF' h=;
 end;
 method run();
 	set TEST2;
 	h_chk(HEIGHT);        /*3*/
 end;
 enddata;
 run;
quit;

/*PG3@forwardo[W*/
proc ds2 ;
 data _null_;
 forward h_chk;
 method run();
 	set TEST2;
 	h_chk(HEIGHT);
 end;
 method h_chk(double h);
 	if . < h < 100 then put
 	'WARNIG:PʊmF' h=;
 end;
 enddata;
 run;
quit;

/*PG4*/
proc ds2 ;
 data OUT2(overwrite=yes);
 forward h_update cal_bsa;                          /*1*/
 declare double BSA;
  method run();
 	set TEST2;
 	h_update(HEIGHT);                               /*2*/
 	BSA=cal_bsa(HEIGHT,WEIGHT);                     /*3*/
 end;
  method h_update(in_out double h);                 /*4*/
 	if . < h < 100 then h=h*100;                    /*5*/
 end;
 method cal_bsa(double h,double w) returns double;  /*6*/
 	declare double result;                          /*7*/
 	result=w**0.425 * h**0.725 * 0.007184;          /*8*/
 	return result;                                  /*9*/
 end;
 enddata;
 run;
quit;

/*PG5*/
proc ds2 ;
 data OUT3(overwrite=yes);
 forward cal_bsa;
 declare double BSA a b ;        /*1*/
 declare char c d ;             /*2*/
  method init();
    a=160;b=50;c='160';d='50';
  	BSA=cal_bsa(a,b);put BSA=;   /*3*/
	BSA=cal_bsa(c,d);put BSA=;   /*4*/
	BSA=cal_bsa(a,b,'VJ');put BSA=;  /*5*/
	BSA=cal_bsa(a,b,'{');put BSA=;  /*6*/
  end;
  method cal_bsa(double h,double w) returns double;  /*7*/
 	declare double result;
 	result=w**0.425 * h**0.725 * 0.007184;
 	return result;
  end;
  method cal_bsa(char h,char w) returns double;      /*8*/
 	declare double result;
 	result=inputn(w,'best32.')**0.425 * inputn(h,'best32.')**0.725 * 0.007184;
 	return result;
 end;
 method cal_bsa(double h,double w,char cm) returns double;  /*9*/
        declare double result;
        if cm ='VJ' then result=w**0.425 * h**0.725 * 0.007358;
        if cm ='{' then result=w**0.444 * h**0.663 * 0.008883;
        return result;
 end;
 enddata;
 run;
quit;

/*PG6*/
proc ds2 ;
 package work.p_bsa/overwrite=yes;                /*1*/
 declare double con; 
 method p_bsa();                                  /*2*/
 	con=100;
 end;
 method h_update(in_out double h);                /*3*/
 	if . < h < con then h=h*con;
 end;
 method cal_bsa(double h,double w) returns double;/*4*/
 	declare double result;
 	result=w**0.425 * h**0.725 * 0.007184;
 	return result;
 end;
 endpackage;                                      /*5*/
run;
quit;

/*PG7*/
proc ds2 ;
data OUT4(overwrite=yes);
declare package work.p_bsa ib(); /*1*/
declare double bsa;
method run();
	set TEST2;
	ib.h_update(HEIGHT);
 	BSA=ib.cal_bsa(HEIGHT,WEIGHT);
end;
enddata;
run;
quit;

data TEST3;
ID=1;AGE=27;COUNTRY='JPN';output;
ID=2;AGE=33;COUNTRY='JPN';output;
ID=4;AGE=52;COUNTRY='USA';output;
ID=5;AGE=41;COUNTRY='JPN';output;
run;

/*PG8 nbVIuWFNg*/
data OUT5;
if 0 then set TEST3; /*A*/
set TEST2;
if _N_=1 then do;    /*B*/
	declare hash h1(dataset:'TEST3');
	h1.definekey('ID');
	h1.definedata('AGE','COUNTRY');
	h1.definedone();
end;
rc=h1.find();
if rc ne 0 then do;  /*C*/
	call missing(AGE ,COUNTRY);
end;
run;

/*PG9@HASHpbP[W*/
proc ds2 ;
	data OUT6(overwrite=yes);
	declare package hash h1();  /*1*/
	declare double AGE;         /*2*/
	declare char COUNTRY;       /*3*/
	method init();              /*4*/
		h1.dataset('TEST3');    /*5*/
		h1.keys([ID]);          /*6*/
		h1.data([AGE COUNTRY]); /*7*/
		h1.definedone();
	end;
	method run();
		set TEST2;
		h1.find();              /*8*/
	end;
	enddata;
	run;
quit;

/*PG10  set܂܂ȂXbh̒`*/
proc ds2 ;
thread th1/overwrite=yes;  /*1*/
 declare double i thread;
 method run();
 	do i = 1 to 15;
 		thread=_threadid_; /*2*/
  		put 'Xbhԍ:'_threadid_ i=;
 		output;
 	end;
 end;
endthread;                 /*3*/
run;
quit;

/*PG11  set܂܂ȂXbh̎s*/
proc ds2 ;
data OUT7(overwrite=yes);
   declare thread th1 t; /*1*/
   declare double NO;
   method run();
   set from t threads=3; /*2*/
   NO=_N_;
   end;
enddata;
run;
quit;

/*PG12  eXgf[^*/
data TEST4;
array ar{100};
do i= 1 to 10000000;
 do j = 1 to 100;
  ar{j}=rand('uniform');
 end;
 output;
 drop i j;
end;
run;

/*PG13  Xbh`*/
proc ds2 ;
thread th/overwrite=yes;
   dcl double count;
   drop count;
   method run();
    set TEST4;
    count +1;
   end;
   method term();
      put 'Xbhԍ' _threadid_ '' count  'obs ǂݍ݂܂';
   end;
endthread;
run;
quit;

/*PG14  Xbhs*/
proc ds2 ;
data OUT8(overwrite=yes);
   dcl thread th t;
   method run();
   set from t threads=3;
   end;
enddata;
run;
quit;

/*PG15  byɂ\[g*/
proc ds2 ;
 data OUT10(overwrite=yes);
  declare double FL;
  method run();
   set TEST2;
   by SEX HEIGHT;  /*1*/
   if last.SEX then FL=1;  /*2*/
  end;
 enddata;
 run;
quit;

/*PG16  setXe[gg{SQL}*/
proc ds2 ;
 data OUT11(overwrite=yes);
 declare double BSA;
  method run();
	set {select SEX,mean(HEIGHT) as HEIGHT ,mean(WEIGHT) as WEIGHT
		 from TEST2
		 group by SEX
		};
	BSA = WEIGHT**0.425 * HEIGHT **0.725 * 0.007184;		
  end;
 enddata;
 run;
quit;

data TEST4;
ID='A';SEX='M';VAL=10;output;
ID='B';SEX='M';VAL=14;output;
ID='C';SEX='M';VAL=13;output;
ID='D';SEX='M';VAL=15;output;
ID='E';SEX='F';VAL=9;output;
ID='F';SEX='F';VAL=8;output;
ID='G';SEX='F';VAL=11;output;
ID='H';SEX='F';VAL=16;output;
run;

/*PG17  HASHpbP[W̃Xe[gg{SQL}*/
proc ds2 ;
 data OUT12(overwrite=yes);
 declare package hash h1();
 declare double ID V_MEAN;
 drop mean;
  method init();
   h1.dataset('{select SEX ,mean(VAL) as V_MEAN
                from TEST4 group by SEX}');
   h1.keys([SEX]);
   h1.data([V_MEAN]);
   h1.definedone(); 
  end;
  method run();
   set TEST2;
   h1.find();
  end;
 enddata;
run;
quit;
